/*
 * Created on 06.06.2008
 */
package Parser;

import java.io.BufferedWriter;
import java.io.File;
import java.io.FileOutputStream;
import java.io.OutputStreamWriter;
import java.util.Arrays;
import java.util.Vector;
import Alignment.HungarianAlignment;
import RealValue.Individual;
import Utilities.Coords;
import Utilities.Graph;

/**
 * @author Thomas Fober
 *         Philipps-Universitt Marburg
 *         Fachbereich Mathematik und Informatik
 *         thomas@mathemetik.uni-marburg.de
 */
public class CreateDistMatrix2 {
	
	double[][] distances;
	Vector<Integer> pos;
	Vector<Integer> neg;
	String[] dataN;
	int[] numberOfNodes;
	
	public static void main(String[] args) {
		String results = args[0];
		String positives = args[1];
		String negatives = args[2];
		double parameter1 = 1;
		double parameter2 = 0.5; 
		CreateDistMatrix2 dist = new CreateDistMatrix2(results, positives, negatives, parameter1, parameter2);
		System.out.println("");
	}
	
	public double valueOf(String path, String graphsPfad, double parameter1, double parameter2){
		//graphen einlesen
		String[] graphsP = path.split("___");
		//String pathFS = path.substring(0, path.lastIndexOf("\\"));
		String pathG1 = graphsPfad+"/"+graphsP[0].substring(graphsP[0].lastIndexOf("\\")+1);
		String pathG2 = graphsPfad+"/"+graphsP[1].substring(0,graphsP[1].lastIndexOf("."));
		Graph[] graphs = new Graph[2]; 
		graphs[0] = ParseGraphs.parseFile(pathG1, 11);
		graphs[1] = ParseGraphs.parseFile(pathG2, 11);
		Vector<Coords>[] m = new Vector[2];
		m[0] = graphs[0].coords;
		m[1] = graphs[1].coords;
		//pco (individual) einlesen
		Individual overlay = new Individual(path, m);
		//alignment berechnen (ung)
		HungarianAlignment alignment = new HungarianAlignment(graphs[0], graphs[1], 11, overlay, parameter1, parameter2);
		return alignment.fitnessAlignment;
	}
	
	public boolean contain(String[] data, String name){
		for(int i = 0; i < data.length; i++){
			if(data[i].equals(name)) return true;
		}
		return false;
	}
	
	public CreateDistMatrix2(String results, String positives, String negatives, double parameter1, double parameter2){
		//distance matrix
		File path = new File(results);
		String[] data = path.list();
//		entferne unntige
		Vector<String> dataNames = new Vector<String>();
		File pathPos = new File(positives);
		String[] dataPos = pathPos.list();
		Arrays.sort(dataPos);
		File pathNeg = new File(negatives);
		String[] dataNeg = pathNeg.list();
		Arrays.sort(dataNeg);
		for(int i = 0; i < data.length; i++){
			String[] pair = data[i].split("___");
			pair[1] = pair[1].substring(0, pair[1].lastIndexOf("."));
			//System.out.println(pair[1]);
			boolean first = false;
			for(int j = 0; j < dataNeg.length; j++){
				if(dataNeg[j].equalsIgnoreCase(pair[0]) || dataNeg[j].equalsIgnoreCase(pair[1])){
					first = true;
					//System.out.println("true set");
					break;
				}
				
			}
			for(int j = 0; j < dataPos.length; j++){
				if(dataPos[j].equalsIgnoreCase(pair[0]) && first || dataPos[j].equalsIgnoreCase(pair[1]) && first){
					dataNames.add(data[i]);
					//System.out.println("Added");
					break;
				}
			}
		}
		System.out.println(dataNames.size());
		data = new String[dataNames.size()];
		for(int i = 0; i < dataNames.size(); i++){
			data[i] = dataNames.get(i);
		}
		Arrays.sort(data);
		int dataLength = (int)(-0.5 + Math.sqrt(0.25 + 2 * data.length));
		int k = 0;
		distances = new double[dataLength][dataLength];
		for(int i = 0; i < dataLength; i++){
			for(int j = i; j < dataLength; j++){
				distances[i][j] = valueOf(results+"\\"+data[k], "C:/Documents and Settings/thomas/Desktop/Graphs", parameter1, parameter2);
				k++;
			}
		}
		for(int i = 0; i < distances.length; i++){
			for(int j = 0; j < distances.length; j++){
				distances[j][i] = distances[i][j];
			}
		}
		
		//pos-/neg-vector
		String[] names = new String[dataLength];
		String name;
		pos = new Vector<Integer>();
		neg = new Vector<Integer>();
		dataN = new String[dataLength];
		for(int i = 0; i < dataLength; i++){
			name = data[i].split("___")[1];
			name = name.substring(0, name.lastIndexOf(".rw"));
			this.dataN[i] = name;
			if(contain(dataPos, name)) pos.add(i); 
			if(contain(dataNeg, name)) neg.add(i);
		}
		
		//////////////////////
		//newNormalizaion();//
		//////////////////////
		
		//write
		try{
	    	BufferedWriter out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("C:\\Documents and Settings\\thomas\\Desktop\\dist.txt")));
	    	for(int i = 0; i < distances.length; i++){
	    		for(int j = 0; j < distances[0].length; j++){
	    			if(j != distances[0].length - 1) out.write(((Double)distances[i][j]).toString() + "\t");
	    			else out.write(((Double)distances[i][j]).toString());
	    		}
	    		out.newLine();
	    	}
	    	out.close();
	    }catch(Exception e){
	    	System.out.println("Error writing distances");
	    }
	    try{
	    	BufferedWriter out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("C:\\Documents and Settings\\thomas\\Desktop\\pos.txt")));
	    	for(int i = 0; i < pos.size(); i++){
	    		if(i != pos.size() - 1) out.write(((Integer)pos.get(i)).toString() + "\t");
	    		else out.write(((Integer)pos.get(i)).toString());
	    	}
	    	out.close();
	    }catch(Exception e){
	    	System.out.println("Error writing positives");
	    }
	    try{
	    	BufferedWriter out = new BufferedWriter(new OutputStreamWriter(new FileOutputStream("C:\\Documents and Settings\\thomas\\Desktop\\neg.txt")));
	    	for(int i = 0; i < neg.size(); i++){
	    		if(i != neg.size() - 1) out.write(((Integer)neg.get(i)).toString() + "\t");
	    		else out.write(((Integer)neg.get(i)).toString());
	    	}
	    	out.close();
	    }catch(Exception e){
	    	System.out.println("Error writing negatives");
	    }
	    ///////////////////////////////////////
	    leaveOneOutTest(distances, pos, neg);//
	    ///////////////////////////////////////
	}
	
	public void newNormalizaion(){
		numberOfNodes = new int[dataN.length];
		Graph g;
		for(int i = 0; i < dataN.length; i++){
			g = ParseGraphs.parseFile("C:\\Documents and Settings\\thomas\\Desktop\\Subset" + "\\" + dataN[i], 11);
			numberOfNodes[i] = g.numberOfNodes;
		}
		for(int i = 0; i < distances.length; i++){
			for(int j = 0; j < distances[0].length; j++){
				//distances[i][j] = distances[i][j] / min(numberOfNodes[i], numberOfNodes[j]);
				distances[i][j] = distances[i][j] / -min(-numberOfNodes[i], -numberOfNodes[j]);
				//distances[i][j] = distances[i][j] / (numberOfNodes[i] + numberOfNodes[j]);
			}
		}
	}
	
	public int min(int a, int b){
		if(a > b) return b;
		else return a;
	}
	
	public int knn(Vector<Integer> positive, Vector<Integer> negative, int querry, int k){
		double[] distance = new double[distances.length];
		int sum = 0;
		int result;
		for(int i = 0; i < distances.length; i++){
			if(querry == i){
				distance[i] = Double.NEGATIVE_INFINITY;
			}else{
				distance[i] = distances[i][querry];
			}
		}
		
		for(int i = 0; i < k; i++){
			result = searchBest(distance);
			sum = sum + (positive.contains(result) ? 1 : -1);
			distance[result] = Double.NEGATIVE_INFINITY;
		}
		if(sum < 0) return -1;
		else if(sum > 0) return 1;
		else if(positive.size() > negative.size()) return 1;
		else return -1;
	}
	
	public static int searchBest(double[] values){
		double bestValue = Double.NEGATIVE_INFINITY;
		int best = 0;
		for(int i = 0; i < values.length; i++){
			if(values[i] > bestValue){
				bestValue = values[i];
				best = i;
			}
		}
		return best;
	}
	
	public void leaveOneOutTest(double[][] distances, Vector<Integer> pos, Vector<Integer> neg){
		int result;
		double correct = 0;
		for(int leave = 0; leave < distances.length; leave++){
			 result = knn(pos, neg, leave, 1);
			 if(result == 1 && pos.contains(leave)) correct++;
			 if(result == -1 && neg.contains(leave)) correct++;
		}
		System.out.println(correct / distances.length);
	}
	
}
